﻿' IDE-Voreinstellungen:
' Option Strict On
' Option Explicit On
' Option Infer On

' Projekt-Voreinstellungen
' Imports System
' Imports System.Windows.Forms
' Imports System.Collections.Generic
' Imports Microsoft.VisualBasic.ControlChars
' Imports System.Linq

Imports System.Runtime.CompilerServices

Public Module Extensions


    ''' <summary> testet vor einer Zuweisung, ob der neue Wert überhaupt eine Änderung bringt </summary>
    ''' <remarks>
    ''' nützlich bei Zuweisungen an performance-intensive Properties, 
    ''' oder wenn auf Änderungen reagiert werden muß
    ''' </remarks>
    <Extension()> _
    Public Function Assign(Of T, T2 As T)(ByRef Dest As T, ByVal Src As T2) As Boolean
        If Object.Equals(Dest, Src) Then Return False
        Dest = Src
        Return True
    End Function

    <Extension()> _
    Public Sub ForEach(Of T)(ByVal Subj As IEnumerable(Of T), ByVal Action As Action(Of T))
        For Each O In Subj
            Action(O)
        Next
    End Sub

    ''' <summary> verkettet alles Strings, fügt Separator dazwischen ein </summary>
    <Extension()> _
    Public Function ToStringX(ByVal Subj As IEnumerable(Of String), ByVal Separator As String) As String
        With New System.Text.StringBuilder
            For Each S In Subj
                .Append(S).Append(Separator)
            Next
            If .Length > 0 Then
                .Remove(.Length - Separator.Length, Separator.Length)
            End If
            Return .ToString
        End With
    End Function

    ''' <summary> fügt ein Object-ParamArray als einen Gesamtstring hinzu </summary>
    <Extension()> _
    Public Sub AddX(ByVal Subj As ICollection(Of String), ByVal ParamArray Items() As Object)
        With New System.Text.StringBuilder
            Items.ForEach(Function(itm) .Append(If(itm, "##Null##")))
            Subj.Add(.ToString())
        End With
    End Sub

End Module
